<script lang="ts">
	import EncodeSelect from "./EncodeSelect.svelte";
	import DecodeSelect from "./DecodeSelect.svelte";

	import morsify 				from "morsify";
	import md5 					from "js-md5";
	import { sha256, sha224 } 	from 'js-sha256';
	import { Base64 as base64 }	from 'js-base64';
	import { caesar } 			from 'simple-cipher-js';
	import vigenere 			from 'vigenere';

	let decodeType = "plain";
	let encodeType = "plain";
	let salt = "";
	let input = "Hello World!";
	let output = "";

	const executeIfSalt = callback => {
		return salt ? callback() : "ERROR! Please fill in salt"
	}

	let usesHash = false;
	$: {
		const typesWithHash = [
			"caesar",
			"vigenere"
		]

		usesHash = typesWithHash.includes(decodeType) || typesWithHash.includes(encodeType)
	}

	const decodes = {
		"plain": 	s => s,
		"morse": 	s => morsify.decode(s),
		"base64":	s => base64.decode(s),
		"caesar":	s => executeIfSalt(() => caesar.decrypt(s, +salt) ),
		"vigenere":	s => executeIfSalt(() => vigenere.decode(s, salt) ),
	}

	const encodes = {
		"plain": 	s => s,
		"morse": 	s => morsify.encode(s),
		"md5": 		s => md5(s),
		"sha224":	s => sha224(s),
		"sha256":	s => sha256(s),
		"base64":	s => base64.encode(s),
		"caesar":	s => executeIfSalt(() => caesar.encrypt(s, +salt) ),
		"vigenere":	s => executeIfSalt(() => vigenere.encode(s, salt) ),
	}

	$: {
		try {
			// convert to plain text
			let plainText = decodes[decodeType](input);

			// convert from plain text
			output = encodes[encodeType](plainText);

			let _ = salt; // done, so svelte will update
		}
		finally { /* TODO: Fix this being needed */ }
	}
</script>

<div id="card">	
	<div id="topBar">
		<DecodeSelect bind:selected={decodeType}/>

		<input type="text" placeholder="Salt" bind:value={salt} disabled={!usesHash} />
		<!-- <input type="text" placeholder="Salt" disabled/> -->

		<EncodeSelect bind:selected={encodeType}/>
	</div>

	<div id="bottomBar">
		<textarea bind:value={input} cols="30" rows="10"></textarea>
		<textarea bind:value={output} cols="30" rows="10"></textarea>
	</div>
</div>

<style>
	#card {
		max-width: 1280px;
		width: 960px;

		background: var(--foreground);
		border-radius: var(--border-radius-medium);

		display: grid;
		box-shadow: var(--shadow);
	}

	#topBar {
		margin: 0.8em;
		display: flex;
		justify-content: space-between;
	}
	
	#bottomBar {
		display: grid;
		grid-template-columns: 1fr 1fr;
	}

	textarea, input {
		border-radius: var(--border-radius-small);
		padding: 0.5em;
		border: 1px solid var(--background-harder);
		margin: 0;

		outline: none;
	}

	input {
		/* border: 1px solid var(--accent-secondary); */
		box-shadow: rgba(0, 0, 0, 0.04) 0px 3px 12px;
	}
	input[disabled]{
		color: var(--background-harder);
		background: var(--background);
	}
	/* input:focus {
		background: var(--background-hard);
	} */
	textarea {
		background: var(--background-hard);
		resize: none;
	}
	textarea:focus {
		background: var(--background);
	}

	textarea:first-child {
		border-radius: 0 0 0 var(--border-radius-medium);
		border-right: 0;
	}
	textarea:last-child {
		border-radius: 0 0 var(--border-radius-medium) 0;
	}
</style>